diff options
| author | sigoden <sigoden@gmail.com> | 2024-11-16 11:09:40 +0800 |
|---|---|---|
| committer | GitHub <noreply@github.com> | 2024-11-16 11:09:40 +0800 |
| commit | 86aa9106090a0219bac30bc12f5a5bd91949afd9 (patch) | |
| tree | 69aef8c03242c67480c4edfe42a2cbf4c785b466 /agents/coder/tools.sh | |
| parent | 6d30c22b82a5ac1a5775d8137c3b08a581770273 (diff) | |
| download | llm-functions-docker-86aa9106090a0219bac30bc12f5a5bd91949afd9.tar.gz | |
refactor: improve bash code (#125)
* refactor: extract guard_path to utils/guard_path.sh
* add utils/guard_operation.sh
Diffstat (limited to 'agents/coder/tools.sh')
| -rwxr-xr-x | agents/coder/tools.sh | 51 |
1 files changed, 3 insertions, 48 deletions
diff --git a/agents/coder/tools.sh b/agents/coder/tools.sh index 6e599e6..c56e734 100755 --- a/agents/coder/tools.sh +++ b/agents/coder/tools.sh @@ -1,64 +1,19 @@ #!/usr/bin/env bash set -e +ROOT_DIR="${LLM_ROOT_DIR:-$(cd "$(dirname "${BASH_SOURCE[0]}")/../.." && pwd)}" + # @env LLM_OUTPUT=/dev/stdout The output path # @cmd Create a new file at the specified path with contents. # @option --path! The path where the file should be created # @option --contents! The contents of the file fs_create() { - _guard_path "$argc_path" Create + "$ROOT_DIR/utils/guard_path.sh" "$argc_path" "Create '$argc_path'?" mkdir -p "$(dirname "$argc_path")" printf "%s" "$argc_contents" > "$argc_path" echo "File created: $argc_path" >> "$LLM_OUTPUT" } -# @cmd Apply changes to a file. Use this when you need to edit an existing file. -# YOU ALWAYS PROVIDE THE FULL FILE CONTENTS WHEN EDITING. NO PARTIAL CONTENTS OR COMMENTS. -# YOU MUST PROVIDE THE FULL FILE CONTENTS. - -# @option --path! The path of the file to edit -# @option --contents! The new contents to apply to the file -# @meta require-tools git -fs_edit() { - if [[ -f "$argc_path" ]]; then - _guard_path "$argc_path" Edit - changed=0 - printf "%s" "$argc_contents" | git diff --no-index "$argc_path" - || { - changed=1 - } - if [[ "$changed" -eq 0 ]]; then - echo "No changes detected." >> "$LLM_OUTPUT" - else - if [ -t 1 ]; then - echo - read -r -p "Apply changes? [Y/n] " ans - if [[ "$ans" == "N" || "$ans" == "n" ]]; then - echo "Aborted!" - exit 1 - fi - fi - printf "%s" "$argc_contents" > "$argc_path" - echo "Applied changes" >> "$LLM_OUTPUT" - fi - else - echo "Not found file: $argc_path" >> "$LLM_OUTPUT" - fi -} - -_guard_path() { - path="$(realpath -m "$1")" - action="$2" - if [[ ! "$path" == "$(pwd)"* ]]; then - if [ -t 1 ]; then - read -r -p "$action $path? [Y/n] " ans - if [[ "$ans" == "N" || "$ans" == "n" ]]; then - echo "Aborted!" - exit 1 - fi - fi - fi -} - # See more details at https://github.com/sigoden/argc eval "$(argc --argc-eval "$0" "$@")" |
